// socket45.h

#define ST_OFF       0
#define ST_LOADED    1
#define ST_RUNNING   2


// Different plugin API versions have different definitions for some
// structures :(

typedef struct _NPWindow1
{
    void*	window;		/* Platform specific window handle */
    uint32	x;			/* Position of top left corner relative */
    uint32	y; 			/*	to a netscape page.					*/
    uint32	width;		/* Maximum window size */
    uint32	height;
    NPRect	clipRect;	/* Clipping rectangle in port coordinates */
						/* Used by MAC only.                      */
} NPWindow1;

typedef struct _NPWindow2
{
    void* window;   /* Platform specific window handle */
    int32 x;      /* Position of top left corner relative */
    int32 y;      /*  to a netscape page.         */
    uint32  width;    /* Maximum window size */
    uint32  height;
    NPRect  clipRect; /* Clipping rectangle in port coordinates */
            /* Used by MAC only.        */
    NPWindowType type;  /* Is this a window or a drawable? */
} NPWindow2;

typedef struct _NPEmbedPrint1
{
    NPWindow1  window;
    void* platformPrint;  /* Platform-specific printing info */
} NPEmbedPrint1;

typedef struct _NPEmbedPrint2
{
    NPWindow2  window;
    void* platformPrint;  /* Platform-specific printing info */
} NPEmbedPrint2;

typedef struct _NPPrint1
{
    uint16  mode;           /* NP_FULL or NP_EMBED */
    union
    {
    NPFullPrint   fullPrint;    /* if mode is NP_FULL */
    NPEmbedPrint1  embedPrint;   /* if mode is NP_EMBED */
    } print;
} NPPrint1;

typedef struct _NPPrint2
{
    uint16  mode;           /* NP_FULL or NP_EMBED */
    union
    {
    NPFullPrint   fullPrint;    /* if mode is NP_FULL */
    NPEmbedPrint2  embedPrint;   /* if mode is NP_EMBED */
    } print;
} NPPrint2;



NPError S45_GetURL(NPP instance, const char* url, const char* window);
NPError S45_PostURL(NPP instance, const char* url, const char* window, uint32 len, const char* buf, NPBool file);
NPError S45_RequestRead(NPStream* stream, NPByteRange* rangeList);
NPError S45_NewStream(NPP instance, NPMIMEType type, const char* window, NPStream** stream);
int32   S45_Write(NPP instance, NPStream* stream, int32 len, void* buffer);
NPError S45_DestroyStream(NPP instance, NPStream* stream, NPReason reason);
void    S45_Status(NPP instance, const char* message);
const char*	 S45_UserAgent(NPP instance);
void*   S45_MemAlloc(uint32 size);
void    S45_MemFree(void* ptr);
uint32  S45_MemFlush(uint32 size);
void    S45_ReloadPlugins(NPBool reloadPages);
JRIEnv* S45_GetJavaEnv(void);
jref    S45_GetJavaPeer(NPP instance);
NPError S45_GetURLNotify(NPP instance, const char* url, const char* window, void* notifyData);
NPError S45_PostURLNotify(NPP instance, const char* url, const char* window, uint32 len, const char* buf, NPBool file, void* notifyData);
NPError S45_GetValue(NPP instance, NPPVariable variable, void *ret_alue);
NPError S45_SetValue(NPP instance, NPNVariable variable, void *ret_alue);
void    S45_InvalidateRect(NPP instance, NPRect *rect);
void    S45_InvalidateRegion(NPP instance, NPRegion region);
void    S45_ForceRedraw(NPP instance);
